Redmine - Defect #12286

Emails of private notes are sent to watcher users regardless of viewing permissions
2012-11-01 11:57 - Ricardo S

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Jean-Philippe Lang % Done: 0%
Category: Email notifications Estimated time: 0.00 hour
Target version: 2.2.0

Resolution: Fixed Affected version:

Description

Mailer for both for issue_add and issue_edit doesn't take watchers' private notes viewing permissions in consideration when
generating the cc list.

A possible solution would be to do the following:
recipients = journal.recipients
watchers = journal.journalized.watcher_users.active
watchers.reject! {|user| !journal.visible? (user)}
cc = watchers.collect (&:mail) - recipients

Being journal.visible? a new method on Journal:
def visible? (usr=User.current)

issue.visible? (usr) && (!private_notes? || usr.allowed_to?(:view_private_notes, project))
end

Related issues:
Related to Redmine - Feature #1554: Private comments in tickets Closed 2008-06-30

Associated revisions

Revision 10789 - 2012-11-05 16:49 - Jean-Philippe Lang

Fixed that watchers receive notifications for private comments without permission (#12286).

History

#1 - 2012-11-01 13:27 - Ricardo S

The affected version is Redmine 2.1.2.devel.10772
The rails version is Rails 3.2.8

#2 - 2012-11-02 10:34 - Arjen van der Veen

| tried the proposed solution and it works for me. Thank you!

#3 - 2012-11-02 12:07 - Daniel Felix

Testet with revision 10781 and works for me.

#4 - 2012-11-02 13:27 - Ricardo S

Daniel, make sure you do the following steps:
1. Login as user U1
2. Assign an user U2 as a watcher on a issue | of project P (user U2 must not have permission to view private notes on that project P)
3. Write a private note on issue |

User U2 now receives a notification email when it shouldn't.

On r10781, neither Mailer nor ActsAsWatchable are fixed so you should still be able to reproduce it:
65| recipients = journal.recipient # Assigns author, assignee selecting those who can view private_notes
66| # Watchers in cc

67| cc = issue.watcher_recipients - recipients # watcher_recipients selects all the watchers that can view
# the issue without rejecting those who can't view private notes

Here's a correction on my solution (I forgot to filter the watchers like it is done on ActsAsWatchable):

recipients = journal.recipients

watchers = journal.journalized.watcher_users.active

watchers.reject! {|user| user.mail_notification == 'none' || !journal.visible? (user)}

cc = watchers.collect (&:mail) .compact - recipients

#5 - 2012-11-02 15:20 - Daniel Felix

Ricardo S wrote:

On r10781, neither Mailer nor ActsAsWatchable are fixed so you should still be able to reproduce it:

Hi Ricardo,

well | meaned that your patch worked for me. Sorry for the missleading note.

I've tried your patch in this revision and it worked for me (it fixes the descripted problem). ;-)
#6 - 2012-11-05 15:15 - Jean-Philippe Lang

- Status changed from New to Confirmed

- Assignee set to Jean-Philippe Lang

#7 - 2012-11-05 15:25 - Jean-Philippe Lang

- Target version set to 2.2.0

#8 - 2012-11-05 17:22 - Jean-Philippe Lang
- Status changed from Confirmed to Closed
- Affected version (unused) set to devel

- Resolution set to Fixed

Fixed with test in r10789, thanks for pointing this out.

2025-07-12 22


https://www.redmine.org/projects/redmine/repository/svn/revisions/10781
https://www.redmine.org/projects/redmine/repository/svn/revisions/10789
http://www.tcpdf.org

